; KALEDIOSCOPE PROGRAM FOR CROMEMCO DAZZLER; 
; PROVIDED BY BILL SUDBRINK
; CONVERTED INTO TASM SOURCE BY RICHARD CINI; JUNE 2, 2010; ALTERNATIVE VERSION
; CONVERTED TO MAC VERSION J. MONAHAN 12/6/2013 (Flipped CR/LF's)


SCROLL		EQU	01H	;SET SCROOL DIRECTION UP.
LF		EQU	0AH
CR		EQU	0DH
BS		EQU	08H	;BACK SPACE (REQUIRED FOR SECTOR DISPLAY)
BELL		EQU	07H
SPACE		EQU	20H
QUIT		EQU	11H	;TURNS OFF ANY SCREEN ENHANCEMENTS (FLASHING, UNDERLINE ETC).
NO$ENHANCEMENT	EQU	17H	;TURNS OFF WHATEVER IS ON
FAST		EQU	10H	;HIGH SPEED SCROOL
TAB		EQU	09H	;TAB ACROSS (8 SPACES FOR SD-BOARD)
ESC		EQU	1BH

; CPM BDOS EQUATES		;Can use before we get started
PRINT		EQU	9
BDOS		EQU	5

;-------------- FOR CONSOLE INPUT & OUTPUT (Cannot use CPM because RAM at 0H is used here)
CONSOL$STATUS	EQU	0H	
CONSOL$IN	EQU	01H
CONSOL$OUT	EQU	01H




	ORG	100H

 	DI			;WE DON'T KNOW, HOW INTERRUPTS WORKS IN THIS SYSTEM, 
 				;SO WE DISABLE THEM. [SP] IS PROBABLY OK FOR A SMALL PROGRAM LIKE THIS

	LXI	SP,100H
 	LXI	D,SIGNON	;PRINT A WELCOME MESSAGE ON CONSOLE
	MVI	C,PRINT
	CALL	BDOS		;PRINT MESSAGE, RETURN
 
	MVI	A,81H		;Diaplay at 1000H
	OUT 	0EH
	MVI	A,30H
	OUT	0FH	
	
L000B:;	IN 	CONSOL$STATUS	;Is an abort being requested
	ANI	02H
	JZ	NOABORT
	IN	CONSOL$IN
	ANI	7FH
	CPI	ESC
	JZ	0F000H		;Just abort back to Z80 Monitor

NOABORT:
	MOV	A,B
	RRC
 	RRC
 	ANA 	D
 	ADD	C
 	MOV	C,A
 	RRC
 	RRC
 	ANA	D
  	MOV 	L,A
  	MOV 	A,B
  	SUB 	L
 	MOV 	B,A
 	PUSH 	B
  	PUSH 	D
  	PUSH 	H
  	LXI 	D,0000H
  	MOV 	A,H
  	ANI 	1FH
  	RAR
  	JC 	L002B
  	MOV 	E,A	; ORIGINAL CODES FOR $7B (MOV A,E) 	
 	RLC
  	RLC
  	RLC
  	RLC
  	MOV 	D,A	; ORIGINAL CODES FOR $7A (MOV A,D)
 
L002B:	MVI 	H,08H
  	CALL 	L005D
  	
  	MOV 	A,B
   	CMA
  	MOV 	B,A
  	MVI	H,06H
  	CALL 	L005D
  	
 	MOV 	A,C
 	CMA
 	MOV 	C,A
 	MVI 	H,02H
  	CALL 	L005D
  	
  	MOV 	A,B
  	CMA
  	MOV 	B,A
  	MVI 	H,04H
  	CALL 	L005D
  	
  	POP 	H
  	POP 	D
  	POP 	B
  	DCR 	E
  	JNZ 	L000B
  	
  	INR 	B
  	INR 	C
  	MVI 	E,3FH
  	DCR 	H
  	JNZ 	L000B
  	
  	INR 	D
  	MVI 	H,1FH
  	JMP 	L000B
 
L005D:	MOV 	A,C
  	ANI 	0F8H
  	RAL
  	MOV 	L,A
  	MOV	A,H
 	ACI 	00H
 	MOV 	H,A
 	MOV 	A,B
 	ANI 	0F8H
 	RAR
 	RAR
 	RAR
 	RAR
 	PUSH 	PSW
 	ADD 	L
 	MOV 	L,A
	POP 	PSW
	MOV 	A,M
 	JC 	L007A
 	
 	ANI 	0F0H
 	ADD 	E
 	MOV 	M,A
 	RET
 
L007A:	ANI 	0FH
 	ADD 	D
 	MOV 	M,A
 	RET
 
SIGNON:	DB	CR,LF,BELL,'Cromemco Dazzler KSCOPE Program. '
	DB	           'Enter ESC to abort to Z80 Monitor',CR,LF,LF,'$'
             
;END
